"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DragMethod = void 0;

var pubo_utils_1 = require("pubo-utils");

var DragMethod =
/** @class */
function () {
  function DragMethod(_a) {
    var _b = _a === void 0 ? {} : _a,
        _c = _b.key,
        key = _c === void 0 ? '' : _c,
        onMove = _b.onMove,
        onMoveEnd = _b.onMoveEnd;

    this.key = '';
    this.cache = {
      pageX: 0,
      pageY: 0
    };
    this.key = key;
    this.onMouseDown = this._onMouseDown.bind(this);
    this.onMouseMove = pubo_utils_1.throttle(this._onMouseMove.bind(this), 1000 / 100);
    this.onMouseUp = this._onMouseUp.bind(this);
    this.onMove = onMove;
    this.onMoveEnd = onMoveEnd;
  }

  DragMethod.prototype._onMouseMove = function (e) {
    if (typeof this.onMove !== 'function') {
      return;
    }

    this.onMove({
      offsetX: e.pageX - this.cache.pageX,
      offsetY: e.pageY - this.cache.pageY,
      key: this.key
    });
    this.cache.pageX = e.pageX;
    this.cache.pageY = e.pageY;
  };

  DragMethod.prototype._onMouseUp = function () {
    window.removeEventListener('mousemove', this.onMouseMove);
    window.removeEventListener('mouseup', this.onMouseUp);

    if (typeof this.onMoveEnd === 'function') {
      this.onMoveEnd();
    }
  };

  DragMethod.prototype._onMouseDown = function (e) {
    if (typeof this.onMove !== 'function') {
      return;
    }

    this.cache.pageX = e.pageX;
    this.cache.pageY = e.pageY;
    window.addEventListener('mousemove', this.onMouseMove);
    window.addEventListener('mouseup', this.onMouseUp);
  };

  return DragMethod;
}();

exports.DragMethod = DragMethod;